// BarView.cpp : implementation file
//

#include "stdafx.h"
#include "MultiDoc.h"
#include "BarView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBarView

IMPLEMENT_DYNCREATE(CBarView, CView)

CBarView::CBarView()
{
}

CBarView::~CBarView()
{
}

BEGIN_MESSAGE_MAP(CBarView, CView)
	//{{AFX_MSG_MAP(CBarView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBarView drawing

void CBarView::OnDraw(CDC* pDC)
{
	CMultiDoc* pDoc = GetDocument();

	//
	// Paint the background.
	//
	CRect rect;
	GetClientRect (&rect);
	CBrush brBackground (pDoc->GetBackColor ());
	pDC->FillRect (rect, &brBackground);

	//
	// Set the mapping mode.
	//
	pDC->SetMapMode (MM_ANISOTROPIC);
	pDC->SetWindowExt (500, 400);
	pDC->SetWindowOrg (-250, -200);
	pDC->SetViewportExt (rect.Width (), rect.Height ());

	//
	// Create a set of brushes.
	//
	CBrush brFillColor[4];
	brFillColor[0].CreateSolidBrush (RGB (255,   0,   0));	// Red
	brFillColor[1].CreateSolidBrush (RGB (  0, 255,   0));	// Green
	brFillColor[2].CreateSolidBrush (RGB (255,   0, 255));	// Magenta
	brFillColor[3].CreateSolidBrush (RGB (  0, 255, 255));	// Cyan

	//
	// Create a pen and select it into the device context.
	//
	CPen pen (PS_SOLID, 0, pDoc->GetForeColor ());
	CPen* pOldPen = pDC->SelectObject (&pen);

	//
	// Draw a bar graph.
	//
	CBrush* pOldBrush = (CBrush*) pDC->SelectStockObject (NULL_BRUSH);
	pDC->Rectangle (-200, -150, 200, 150);

	for (int i=0; i<4; i++) {
		int x1 = (i * 100) - 200;
		int y1 = 150 - ((pDoc->GetRevenue (i) * 3) / 5);
		int x2 = x1 + 100;
		int y2 = 150;
		pDC->SelectObject (&brFillColor[i]);
		pDC->Rectangle (x1, y1, x2, y2);
	}

	pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

/////////////////////////////////////////////////////////////////////////////
// CBarView diagnostics

#ifdef _DEBUG
void CBarView::AssertValid() const
{
	CView::AssertValid();
}

void CBarView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMultiDoc* CBarView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMultiDoc)));
	return (CMultiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBarView message handlers
