// MultiDoc.cpp : implementation of the CMultiDoc class
//

#include "stdafx.h"
#include "MultiView.h"
#include "MultiDoc.h"
#include "Revenues.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMultiDoc

IMPLEMENT_DYNCREATE(CMultiDoc, CDocument)

BEGIN_MESSAGE_MAP(CMultiDoc, CDocument)
	//{{AFX_MSG_MAP(CMultiDoc)
	ON_COMMAND(ID_BACKGROUND_WHITE, OnBackgroundWhite)
	ON_COMMAND(ID_BACKGROUND_YELLOW, OnBackgroundYellow)
	ON_COMMAND(ID_BACKGROUND_BLUE, OnBackgroundBlue)
	ON_COMMAND(ID_BACKGROUND_BLACK, OnBackgroundBlack)
	ON_UPDATE_COMMAND_UI(ID_BACKGROUND_WHITE, OnUpdateBackgroundWhite)
	ON_UPDATE_COMMAND_UI(ID_BACKGROUND_YELLOW, OnUpdateBackgroundYellow)
	ON_UPDATE_COMMAND_UI(ID_BACKGROUND_BLUE, OnUpdateBackgroundBlue)
	ON_UPDATE_COMMAND_UI(ID_BACKGROUND_BLACK, OnUpdateBackgroundBlack)
	ON_COMMAND(ID_EDIT_REVENUES, OnEditRevenues)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiDoc construction/destruction

CMultiDoc::CMultiDoc()
{
	// TODO: add one-time construction code here

}

CMultiDoc::~CMultiDoc()
{
}

BOOL CMultiDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_nRevenues[0] = 372;
	m_nRevenues[1] = 112;
	m_nRevenues[2] = 365;
	m_nRevenues[3] = 446;

	m_crBackColor = RGB (255, 255, 255);
	m_crForeColor = RGB (0, 0, 0);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMultiDoc serialization

void CMultiDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		for (int i=0; i<4; i++)
			ar << m_nRevenues[i];
		ar << m_crBackColor << m_crForeColor;
	}
	else
	{
		for (int i=0; i<4; i++)
			ar >> m_nRevenues[i];
		ar >> m_crBackColor >> m_crForeColor;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMultiDoc diagnostics

#ifdef _DEBUG
void CMultiDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMultiDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMultiDoc commands

int CMultiDoc::GetRevenue (int nQuarter)
{
	int nResult = -1;
	if ((nQuarter >= 0) && (nQuarter <= 3))
		nResult = m_nRevenues[nQuarter];
	return nResult;
}

COLORREF CMultiDoc::GetBackColor ()
{
	return m_crBackColor;
}

COLORREF CMultiDoc::GetForeColor ()
{
	return m_crForeColor;
}

void CMultiDoc::OnBackgroundWhite() 
{
	m_crBackColor = RGB (255, 255, 255);
	m_crForeColor = RGB (0, 0, 0);
	UpdateAllViews (NULL);
	SetModifiedFlag ();
}

void CMultiDoc::OnBackgroundYellow() 
{
	m_crBackColor = RGB (255, 255, 0);
	m_crForeColor = RGB (0, 0, 192);
	UpdateAllViews (NULL);
	SetModifiedFlag ();
}

void CMultiDoc::OnBackgroundBlue() 
{
	m_crBackColor = RGB (0, 0, 192);
	m_crForeColor = RGB (255, 255, 0);
	UpdateAllViews (NULL);
	SetModifiedFlag ();
}

void CMultiDoc::OnBackgroundBlack() 
{
	m_crBackColor = RGB (0, 0, 0);
	m_crForeColor = RGB (255, 255, 255);
	UpdateAllViews (NULL);
	SetModifiedFlag ();
}

void CMultiDoc::OnUpdateBackgroundWhite(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_crBackColor == RGB (255, 255, 255));
}

void CMultiDoc::OnUpdateBackgroundYellow(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_crBackColor == RGB (255, 255, 0));
}

void CMultiDoc::OnUpdateBackgroundBlue(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_crBackColor == RGB (0, 0, 192));
}

void CMultiDoc::OnUpdateBackgroundBlack(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_crBackColor == RGB (0, 0, 0));
}

void CMultiDoc::OnEditRevenues() 
{
	CRevenuesDialog dlg;

	dlg.m_nQ1 = m_nRevenues[0];
	dlg.m_nQ2 = m_nRevenues[1];
	dlg.m_nQ3 = m_nRevenues[2];
	dlg.m_nQ4 = m_nRevenues[3];

	if (dlg.DoModal () == IDOK) {
		m_nRevenues[0] = dlg.m_nQ1;
		m_nRevenues[1] = dlg.m_nQ2;
		m_nRevenues[2] = dlg.m_nQ3;
		m_nRevenues[3] = dlg.m_nQ4;
		UpdateAllViews (NULL);
		SetModifiedFlag ();
	}	
}
