// PieView.cpp : implementation of the CPieView class
//

#include "stdafx.h"
#include <math.h>

#include "MultiView.h"

#include "MultiDoc.h"
#include "PieView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPieView

IMPLEMENT_DYNCREATE(CPieView, CView)

BEGIN_MESSAGE_MAP(CPieView, CView)
	//{{AFX_MSG_MAP(CPieView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPieView construction/destruction

CPieView::CPieView()
{
	// TODO: add construction code here

}

CPieView::~CPieView()
{
}

BOOL CPieView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPieView drawing

void CPieView::OnDraw(CDC* pDC)
{
	CMultiDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//
	// Paint the background.
	//
	CRect rect;
	GetClientRect (&rect);
	CBrush brBackground (pDoc->GetBackColor ());
	pDC->FillRect (rect, &brBackground);

	//
	// Set the mapping mode.
	//
	pDC->SetMapMode (MM_ANISOTROPIC);
	pDC->SetWindowExt (500, 400);
	pDC->SetWindowOrg (-250, -200);
	pDC->SetViewportExt (rect.Width (), rect.Height ());

	//
	// Create a set of brushes.
	//
	CBrush brFillColor[4];
	brFillColor[0].CreateSolidBrush (RGB (255,   0,   0));	// Red
	brFillColor[1].CreateSolidBrush (RGB (  0, 255,   0));	// Green
	brFillColor[2].CreateSolidBrush (RGB (255,   0, 255));	// Magenta
	brFillColor[3].CreateSolidBrush (RGB (  0, 255, 255));	// Cyan

	//
	// Create a pen and select it into the device context.
	//
	CPen pen (PS_SOLID, 0, pDoc->GetForeColor ());
	CPen* pOldPen = pDC->SelectObject (&pen);

	//
	// Draw a pie chart.
	//
	int nTotal = 0;
	for (int i=0; i<4; i++)
		nTotal += pDoc->GetRevenue (i);

	int x1 = 0;
	int y1 = -1000;
	int nSum = 0;

	for (i=0; i<4; i++) {
		nSum += pDoc->GetRevenue (i);
		int x2 = GetXCoord (nSum, nTotal);
		int y2 = GetYCoord (nSum, nTotal);
		pDC->SelectObject (&brFillColor[i]);
		pDC->Pie (-200, -150, 200, 150, x1, y1, x2, y2);
		x1 = x2;
		y1 = y2;
	}

	pDC->SelectStockObject (WHITE_BRUSH);
	pDC->SelectObject (pOldPen);
}

/////////////////////////////////////////////////////////////////////////////
// CPieView printing

BOOL CPieView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPieView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPieView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPieView diagnostics

#ifdef _DEBUG
void CPieView::AssertValid() const
{
	CView::AssertValid();
}

void CPieView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMultiDoc* CPieView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMultiDoc)));
	return (CMultiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPieView message handlers

int CPieView::GetXCoord (int nValue, int nBasis)
{
	double rad = ((double) nValue * 6.2832 / (double) nBasis) + 3.1416;
	return (int) (sin (rad) * 1000);
}

int CPieView::GetYCoord (int nValue, int nBasis)
{
	double rad = ((double) nValue * 6.2832 / (double) nBasis) + 3.1416;
	return (int) (cos (rad) * 1000);
}
